## gle-graphics 4.3.7

=== src/CMakeLists.txt ===
#
# -- CMakeLists.txt for GLE - Graphics Layout Engine
#
cmake_minimum_required (VERSION 3.18)
cmake_policy(SET CMP0091 NEW) 	# windows static runtimes selection
#cmake_policy(SET CMP0167 NEW)	# The FindBoost module is removed. only for cmake 3.30 and later live with the warning for now
cmake_policy(SET CMP0074 NEW)	# uses <PackageName>_ROOT variables.
include(CheckIncludeFile)
include(CheckIncludeFiles)
include(CheckIncludeFileCXX)
include(CMakePrintHelpers)

find_package(ECM CONFIG NO_MODULE) # optional extra-cmake-modules needed for find_poppler
if(ECM_FOUND)
	list(INSERT CMAKE_MODULE_PATH 0 ${ECM_MODULE_PATH})
endif()

set( CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple
project( gle VERSION 4.3.7 )
add_compile_definitions(GLEVN="${PROJECT_VERSION}")
set( CMAKE_DEBUG_POSTFIX  "d")
#
# -- options
#
set(BUILD_MANIP_DEFAULT ON)
if(WIN32)
	# not working yet
	set(BUILD_MANIP_DEFAULT OFF)
endif()

option(BUILD_GUI "Build the GUI - gle Previewer" ON)
option(BUILD_MANIP "Build manip program" BUILD_MANIP_DEFAULT)
option(MSVC_USE_STATIC_RUNTIME "Build and link against the windows static runtime (/MT) (windows only)" OFF)
option(GLE_EXAMPLES_LIBRARY_PATH "Path to gle-examples.  Only needed when using cpack to build distributables" "./gle-examples")
option(GLE_USER_MANUAL_PATH "Path to gle-manual when gle-manual.pdf resides.  Only needed when using cpack to build distributables" "./gle-manual")
option(EXTRA_GSLIB_SEARCH_LOCATION "Extra path for searching for gslib on linux and macOS" OFF)

if(NOT DEFINED POPPLER_INTERFACE)
	# poppler interface defaults if not set -> CPP for Windows, GLIB for Linux and Apple/Darwin
	# CPP interface to poppler is *more* cross platform and does not rely on GLIB2.
	# vcpkg only installs the cpp interface for windows
	set(POPPLER_INTERFACE_DEFAULT "CPP")
	if(UNIX OR APPLE)
		set(POPPLER_INTERFACE_DEFAULT "GLIB")
	endif()
	set(POPPLER_INTERFACE ${POPPLER_INTERFACE_DEFAULT} CACHE STRING "The poppler (PDFLibarary) interface to utilize GLIB or CPP")
endif()
#
# -- Windows option for static runtimes
#
if(WIN32)
	#
	# -- Windows option for runtime library - assume DLL /MD unless MSVC_USE_STATIC_RUNTIME=ON then use static /MT
	#
	set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>DLL")
	if(DEFINED MSVC_USE_STATIC_RUNTIME AND MSVC_USE_STATIC_RUNTIME)
		set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
		# tag CPACK_SYSTEM_NAME with "s" to denote static runtime - must rebuild the whole name as there is no way to add a tag
		set(CPACK_SYSTEM_NAME "win64s")
		if(${CMAKE_VS_PLATFORM_NAME} STREQUAL "Win32")
			set(CPACK_SYSTEM_NAME "win32s")
		endif()
	endif()
endif()
if (POLICY CMP0069)
	# link-time or inter-process optimization LTO or IPO
	cmake_policy(SET CMP0069 NEW)
	include(CheckIPOSupported)
	check_ipo_supported(RESULT IPO_SUPPORTED)
	if ( IPO_SUPPORTED )
		# only set for release builds - this will apply to all targets: .obj, .exe, .so, .dll, .lib, .a
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_RELEASE ON)
		set(CMAKE_INTERPROCEDURAL_OPTIMIZATION_DEBUG OFF)
	endif()
endif()
#
# -- cpack information  (need more here for NSIS and others - manual and sample gle files)
#
set(CPACK_PACKAGE_VENDOR "GLE")
set(CPACK_VERBATIM_VARIABLES true)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GLE Graphics Programming Language")
#set(CPACK_PACKAGE_DESCRIPTION_FILE )
#set(CPACK_RESOURCE_FILE_WELCOME )
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../doc/LICENSE.txt")
set(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/../doc/README.txt")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "GLE")
#
# - NSIS specific settings
#
set(CPACK_NSIS_COMPRESSOR "lzma")
set(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}/gui/images\\gle.ico")
set(CPACK_NSIS_MUI_UNIICON "${CMAKE_CURRENT_SOURCE_DIR}/gui/images\\gle.ico")
set(CPACK_NSIS_MUI_HEADERIMAGE "${CMAKE_CURRENT_SOURCE_DIR}/../graphics\\nsis_banner_image.bmp")
set(CPACK_NSIS_MUI_WELCOMEFINISHPAGE_BITMAP "${CMAKE_CURRENT_SOURCE_DIR}/../graphics\\nsis_welcome_image.bmp")
set(CPACK_NSIS_WELCOME_TITLE "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_BRANDING_TEXT "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_DISPLAY_NAME "GLE ${PROJECT_VERSION}")
set(CPACK_NSIS_ENABLE_UNINSTALL_BEFORE_INSTALL OFF)
set(CPACK_NSIS_MODIFY_PATH ON)
set(CPACK_PACKAGE_EXECUTABLES 	"qgle" "GLE Previewer"  )
set(CPACK_NSIS_MENU_LINKS
	"doc/gle-manual.pdf" "GLE Manual"
	"https://glx.sourceforge.io" "GLE Web Site"
	"https://github.com/vlabella/GLE" "GLE GitHub page"
)
# extra commands include finddeps and setting file associations
set(CPACK_NSIS_EXTRA_INSTALL_COMMANDS "
	Exec \"$INSTDIR\\bin\\qgle.exe -finddeps '$INSTDIR\\glerc.old'\"
	WriteRegStr HKCR '.gle' '' 'GLEFile'
  	WriteRegStr HKCR 'GLEFile' '' 'GLE Script'
  	WriteRegStr HKCR 'GLEFile\\DefaultIcon' '' '$INSTDIR\\bin\\qgle.exe,0'
  	WriteRegStr HKCR 'GLEFile\\shell\\open\\command' '' '$INSTDIR\\bin\\qgle.exe \"%1\"'
  	WriteRegStr HKCR 'GLEFile\\shell\\edit' '' 'Edit GLE Script'
  	WriteRegStr HKCR 'GLEFile\\shell\\edit\\command' '' '$INSTDIR\\bin\\qgle.exe \"%1\"'
  	System::Call 'Shell32::SHChangeNotify(i 0x8000000, i 0, i 0, i 0)'
")
set (CPACK_NSIS_EXTRA_UNINSTALL_COMMANDS "
	DeleteRegKey HKCR '.gle'
    DeleteRegKey HKCR 'GLEFile'
")
#
# -- wix specific settings unused no .msi generated
# dont change these GUIDs once generated
#set(CPACK_WIX_UPGRADE_GUID "" )
#set(CPACK_WIX_PRODUCT_GUID "" )
#set(CPACK_WIX_PRODUCT_ICON "")
#
# -- DragNDrop MacOS dmg settings
#
set(CPACK_DMG_FORMAT "UDBZ")

include(CPack)
#
# -- create text file with version information in it for reading in a makefile
#
string(TOLOWER ${CMAKE_PROJECT_NAME} CMAKE_PROJECT_NAME_LC )
FILE(WRITE
${CMAKE_CURRENT_SOURCE_DIR}/../project_info.mak
"#\n"
"# -- project_info.mak - Auto generated by CmakeLists.txt\n"
"#    DO NOT EDIT - ALL CHANGES WILL BE LOST\n"
"#\n"
"PROJECT_NAME		=${CMAKE_PROJECT_NAME}\n"
"PROJECT_NAME_LC		=${CMAKE_PROJECT_NAME_LC}\n"
"SYSTEM_NAME 		=${CPACK_SYSTEM_NAME}\n"
"VERSION_NUMBER		=${PROJECT_VERSION}\n"
"PACKAGE_BASE		=\$(PROJECT_NAME)-\$(VERSION_NUMBER)\n"
"PACKAGE_BASENAME	=\$(PACKAGE_BASE)-\$(SYSTEM_NAME)\n"
)
#
# -- external libraries user can pass ***_ROOT to modify search location
#
find_package(ZLIB REQUIRED)
SET(Boost_USE_STATIC_LIBS ON)
find_package(Boost)
find_package(JPEG)
if(BUILD_MANIP)
	# manip needs curses or pdcurses on windows
	if(UNIX OR APPLE)
		find_package(Curses REQUIRED)
	else()
		set(CURSES_FOUND)
		get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
		if(_isMultiConfig)
			find_library(CURSES_RELEASE NAMES pdcurses PATHS ${CURSES_ROOT} PATH_SUFFIXES lib lib64 )
			string(COMPARE NOTEQUAL "${CURSES_RELEASE}" "CURSES_RELEASE-NOTFOUND" CURSES_FOUND)
			find_library(CURSES_DEBUG NAMES pdcursesd PATHS ${CURSES_ROOT} PATH_SUFFIXES lib lib64 )
			set(HAS_DEBUG )
			string(COMPARE NOTEQUAL "${CURSES_DEBUG}" "CURSES_DEBUG-NOTFOUND" HAS_DEBUG)
			if(HAS_DEBUG)
				list(APPEND CURSES_LIBRARIES "optimized")
				list(APPEND CURSES_LIBRARIES ${CURSES_RELEASE})
				list(APPEND CURSES_LIBRARIES "debug")
				list(APPEND CURSES_LIBRARIES ${CURSES_DEBUG})
			else()
				list(APPEND CURSES_LIBRARIES ${CURSES_RELEASE})
			endif()
		else()
			find_library(CURSES_LIBRARIES NAMES pdcurses pdcursesd PATHS ${CURSES_ROOT} PATH_SUFFIXES lib lib64 )
			string(COMPARE NOTEQUAL "${CURSES_LIBRARIES}" "CURSES_LIBRARIES-NOTFOUND" CURSES_FOUND)
		endif()
		find_path(CURSES_INCLUDE_DIRS curses.h PATHS ${CURSES_ROOT} PATH_SUFFIXES include include/pdcurses )
		if(CURSES_FOUND)
			message(STATUS "Found LIBCURSES: ${CURSES_LIBRARIES}" )
		endif()
	endif()
endif()
find_package(TIFF)

if(WIN32 AND TIFF_FOUND)
	#
	# -- find optional packages for LibTIFF only if linking against static libraries on windows
	#
	find_package(LibLZMA) # -- for libTIFF optional
	find_package(JBIG) # -- for libtiff optional
	if(JBIG_FOUND)
		message(STATUS "Found JBIG" )
	endif()
	find_package(ZSTD) # -- for libtiff optional
	if(ZSTD_FOUND)
		message(STATUS "Found ZSTD" )
	endif()
	#
	# -- libdeflate for libtiff - optional
	#
	set(DEFLATE_FOUND)
	get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
	if(_isMultiConfig)
		find_library(DEFLATE_RELEASE NAMES libdeflate libdeflatestatic PATHS ${DEFLATE_ROOT} PATH_SUFFIXES lib )
		string(COMPARE NOTEQUAL "${DEFLATE_RELEASE}" "DEFLATE_RELEASE-NOTFOUND" DEFLATE_FOUND)
		find_library(DEFLATE_DEBUG NAMES defalted libdeflatestaticd PATHS ${DEFLATE_ROOT} PATH_SUFFIXES lib )
		set(HAS_DEBUG )
		string(COMPARE NOTEQUAL "${DEFLATE_DEBUG}" "DEFLATE_DEBUG-NOTFOUND" HAS_DEBUG)
		if(HAS_DEBUG)
			list(APPEND DEFLATE_LIBRARIES "optimized")
			list(APPEND DEFLATE_LIBRARIES ${DEFLATE_RELEASE})
			list(APPEND DEFLATE_LIBRARIES "debug")
			list(APPEND DEFLATE_LIBRARIES ${DEFLATE_DEBUG})
		else()
			list(APPEND DEFLATE_LIBRARIES ${DEFLATE_RELEASE})
		endif()
	else()
		find_library(DEFLATE_LIBRARIES NAMES deflate deflated libdeflate.a libdeflated.a PATHS ${DEFLATE_ROOT} PATH_SUFFIXES lib )
		string(COMPARE NOTEQUAL "${DEFLATE_LIBRARIES}" "DEFLATE_LIBRARIES-NOTFOUND" DEFLATE_FOUND)
	endif()
	find_path(DEFLATE_INCLUDE_DIRS libdeflate.h PATHS ${DEFLATE_ROOT} PATH_SUFFIXES include )
	if(DEFLATE_FOUND)
		message(STATUS "Found LIBDEFLATE: ${DEFLATE_LIBRARIES}" )
	endif()
endif()
# note findPNG calls findZLIB
find_package(PNG )
# find debug if it exists for multi config generators only
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(PNG_DEBUG NAMES pngd libpngd PATHS ${PNG_ROOT} PATH_SUFFIXES lib )
	if(NOT ${PNG_DEBUG} STREQUAL "PNG_DEBUG-NOTFOUND" )
		list(INSERT PNG_LIBRARIES 0 "optimized")
		list(APPEND PNG_LIBRARIES "debug")
		list(APPEND PNG_LIBRARIES ${PNG_DEBUG})
	endif()
endif()
#find_package(Cairo )
#find_package(Pixman )
#
# -- cairo library - cmake does not supply findCAIRO.cmake
#
set(CAIRO_FOUND )
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(CAIRO_RELEASE NAMES cairo PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib REQUIRED )
	string(COMPARE NOTEQUAL "${CAIRO_RELEASE}" "CAIRO_RELEASE-NOTFOUND" CAIRO_FOUND)
	find_library(CAIRO_DEBUG NAMES cairod PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib )
	set(HAS_DEBUG )
	string(COMPARE NOTEQUAL "${CAIRO_DEBUG}" "CAIRO_DEBUG-NOTFOUND" HAS_DEBUG)
	if(HAS_DEBUG)
		list(APPEND CAIRO_LIBRARIES "optimized")
		list(APPEND CAIRO_LIBRARIES ${CAIRO_RELEASE})
		list(APPEND CAIRO_LIBRARIES "debug")
		list(APPEND CAIRO_LIBRARIES ${CAIRO_DEBUG})
	else()
		list(APPEND CAIRO_LIBRARIES ${CAIRO_RELEASE})
	endif()
else()
	find_library(CAIRO_LIBRARIES NAMES cairo cairod PATHS ${CAIRO_ROOT} PATH_SUFFIXES lib REQUIRED)
	string(COMPARE NOTEQUAL "${CAIRO_LIBRARIES}" "CAIRO_LIBRARIES-NOTFOUND" CAIRO_FOUND)
endif()
find_path(CAIRO_INCLUDE_DIRS cairo.h PATHS ${CAIRO_ROOT} PATH_SUFFIXES include include/cairo REQUIRED)
if(CAIRO_FOUND)
	message(STATUS "Found CAIRO: ${CAIRO_LIBRARIES}" )
endif()
#
# -- pixman library - cmake does not supply findPIXMAN.cmake
#
set(PIXMAN_FOUND )
get_property(_isMultiConfig GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
if(_isMultiConfig)
	find_library(PIXMAN_RELEASE NAMES pixman pixman-1 PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib REQUIRED)
	string(COMPARE NOTEQUAL "${PIXMAN_RELEASE}" "PIXMAN_RELEASE-NOTFOUND" PIXMAN_FOUND)
	find_library(PIXMAN_DEBUG NAMES pixmand pixmand-1 PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib )
	set(HAS_DEBUG )
	string(COMPARE NOTEQUAL "${PIXMAN_DEBUG}" "PIXMAN_DEBUG-NOTFOUND" HAS_DEBUG)
	if(HAS_DEBUG)
		list(APPEND PIXMAN_LIBRARIES "optimized")
		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
		list(APPEND PIXMAN_LIBRARIES "debug")
		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_DEBUG})
	else()
		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
	endif()
else()
	find_library(PIXMAN_LIBRARIES NAMES pixman pixmand pixman-1 PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib REQUIRED)
	string(COMPARE NOTEQUAL "${PIXMAN_LIBRARIES}" "PIXMAN_LIBRARIES-NOTFOUND" PIXMAN_FOUND)

=== src/TeX/CMakeLists.txt ===
#
# -- generate inittex.ini from init.tex
#
# set(OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/../gle)

# # crazy specializaton here
# if(WIN32)
# set(GLE ${OUTPUT_DIR}$<$<PLATFORM_ID:Windows>:$<IF:$<CONFIG:debug>,/Debug,/Release>>/gle$<$<CONFIG:Debug>:d> )

# add_custom_command(
# 	OUTPUT ${OUTPUT_DIR}/inittex.ini
# 	DEPENDS init.tex
# 	COMMAND ${CMAKE_COMMAND} -E make-directory ${OUTPUT_DIR}/bin
# 	COMMAND ${CMAKE_COMMAND} -E create_symlink ${OUTPUT_DIR}/gle ${OUTPUT_DIR}/bin/gle
# 	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/init.tex ${OUTPUT_DIR}/init.tex
# 	COMMAND ${GLE} -mkinittex
# 	WORKING_DIRECTORY ${OUTPUT_DIR}/bin
# 	COMMENT "Generating inittex.ini from init.tex"
# )
# else()
# set(GLE ${OUTPUT_DIR}$<$<PLATFORM_ID:Windows>:$<IF:$<CONFIG:debug>,/Debug,/Release>>/gle$<$<CONFIG:Debug>:d> )

# add_custom_command(
# 	OUTPUT ${OUTPUT_DIR}/inittex.ini
# 	DEPENDS init.tex
# 	COMMAND ${CMAKE_COMMAND} -E make-directory ${OUTPUT_DIR}/bin
# 	COMMAND ${CMAKE_COMMAND} -E create_symlink ${OUTPUT_DIR}/gle ${OUTPUT_DIR}/bin/gle
# 	COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/init.tex ${OUTPUT_DIR}/init.tex
# 	COMMAND ${GLE} -mkinittex
# 	WORKING_DIRECTORY ${OUTPUT_DIR}/bin
# 	COMMENT "Generating inittex.ini from init.tex"
# )


# endif()
# add_custom_target(inittex ALL DEPENDS
# 	${OUTPUT_DIR}/inittex.ini
# 	gle
# )

# install(FILES
# 	${OUTPUT_DIR}/inittex.ini
# 	${OUTPUT_DIR}/init.tex
# 	CONFIGURATIONS Release Debug
# 	DESTINATION .
# )

install(FILES
	init.tex
	CONFIGURATIONS Release Debug
 	DESTINATION .
)
# make the inittex.ini in the install folder
install(CODE
	"execute_process(COMMAND \$ENV{DESTDIR}${CMAKE_INSTALL_PREFIX}/bin/gle$<$<CONFIG:Debug>:d> -mkinittex)"
)

=== src/fbuild/CMakeLists.txt ===
add_executable(fbuild
	fbuild.cpp
	../gle/token.cpp
	../gle/cutils.cpp
	../gle/file_io.cpp
)
if(WIN32)
	target_link_libraries(fbuild LINK_PUBLIC Ws2_32.lib ) 
endif()
set_target_properties(fbuild PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 

install(TARGETS fbuild
		CONFIGURATIONS Release Debug
		RUNTIME )

=== src/fonts/CMakeLists.txt ===
#
# -- font files - create .fve and .afm files for packaging with binary executable
#
# .fve file are created from .gle files of the same name using fbuild
# .afm files are created frin .fmt files using makefmt
#
# all targets (.fve and .afm) files are put in the same /font folder in the distro
#
# -- list of targets to build
#
set(FVE_FILES 
	glemark.fve
	plba.fve
	plcc.fve
	plcg.fve
	plci.fve
	plcr.fve
	plcs.fve
	pldr.fve
	plge.fve
	plgg.fve
	plgi.fve
	plsa.fve
	plsg.fve
	plsr.fve
	plss.fve
	plsym1.fve
	plsym2.fve
	plti.fve
	pltr.fve
	texcmb.fve
	texcmex.fve
	texcmitt.fve
	texcmmi.fve
	texcmr.fve
	texcmss.fve
	texcmssb.fve
	texcmssi.fve
	texcmsy.fve
	texcmti.fve
	texcmtt.fve
)

set(FMT_FILES 
	glemark.fmt 
	plba.fmt
	plcc.fmt
	plcg.fmt
	plci.fmt
	plcr.fmt
	plcs.fmt
	pldr.fmt
	plge.fmt
	plgg.fmt
	plgi.fmt
	plsa.fmt
	plsg.fmt
	plsr.fmt
	plss.fmt
	plsym1.fmt
	plsym2.fmt
	plti.fmt
	pltr.fmt
	pshc.fmt
	pshcb.fmt
	pshcbo.fmt
	pshcdo.fmt
	texcmb.fmt
	texcmex.fmt
	texcmitt.fmt
	texcmmi.fmt
	texcmr.fmt
	texcmsl.fmt
	texcmss.fmt
	texcmssb.fmt
	texcmssi.fmt
	texcmsy.fmt
	texcmti.fmt
	texcmtt.fmt 
	cyrillic/arial8.fmt    
	cyrillic/arialbd8.fmt  
	cyrillic/arialbi8.fmt 
	cyrillic/ariali8.fmt
	cyrillic/cokoi8b.fmt  
	cyrillic/cokoi8bi.fmt  
	cyrillic/cokoi8i.fmt  
	cyrillic/cokoi8n.fmt  
	cyrillic/times8.fmt 
	cyrillic/timesbd8.fmt
	cyrillic/timesbi8.fmt 
	cyrillic/timesi8.fmt
)
# specialization for Adboe files the source names are not the same as the target names
set(ADOBE_FMT_FILES 
	psagb.fmt
	psagbo.fmt
	psagd.fmt
	psagdo.fmt
	psbd.fmt
	psbdi.fmt
	psbl.fmt
	psbli.fmt
	psc.fmt
	pscb.fmt
	pscbo.fmt
	psco.fmt
	pshb.fmt
	pshbo.fmt
	psh.fmt
	pshn.fmt
	pshnb.fmt
	pshnbo.fmt
	pshno.fmt
	psho.fmt
	psncsb.fmt
	psncsbi.fmt
	psncsi.fmt
	psncsr.fmt
	pspb.fmt
	pspbi.fmt
	pspi.fmt
	pspr.fmt
	pssym.fmt
	pstb.fmt
	pstbi.fmt
	psti.fmt
	pstr.fmt
	pszcmi.fmt
	pszd.fmt
)

set(MAKEFMT ${CMAKE_CURRENT_BINARY_DIR}/../makefmt/$<$<PLATFORM_ID:Windows>:$<IF:$<CONFIG:debug>,Debug,Release>>/makefmt$<$<CONFIG:Debug>:d> )
set(FBUILD  ${CMAKE_CURRENT_BINARY_DIR}/../fbuild/$<$<PLATFORM_ID:Windows>:$<IF:$<CONFIG:debug>,Debug,Release>>/fbuild$<$<CONFIG:Debug>:d> )
set(ADOBE35 Adobe-Core35_AFMs-314)
# all font files are built and put in the binary dir
set(OUTPUT_DIR ${CMAKE_CURRENT_BINARY_DIR}/../gle/font)

# Adobe specialization file mapping of adobe names to gle names
foreach( fmt_file ${ADOBE_FMT_FILES} )
	set(OPTIONE -e adobestd.enc)
	if( ${fmt_file} STREQUAL psagb.fmt )
		set(afm_file ITCAvantGarde-Book.afm )
	elseif( ${fmt_file} STREQUAL psagbo.fmt )
		set(afm_file ITCAvantGarde-BookOblique.afm )
	elseif( ${fmt_file} STREQUAL psagd.fmt)
		set(afm_file ITCAvantGarde-Demi.afm)
	elseif( ${fmt_file} STREQUAL psagdo.fmt)
		set(afm_file ITCAvantGarde-DemiOblique.afm)
	elseif( ${fmt_file} STREQUAL psbd.fmt)
		set(afm_file ITCBookman-Demi.afm)
	elseif( ${fmt_file} STREQUAL psbdi.fmt)
		set(afm_file ITCBookman-DemiItalic.afm)
	elseif( ${fmt_file} STREQUAL psbli.fmt)
		set(afm_file ITCBookman-LightItalic.afm)
	elseif( ${fmt_file} STREQUAL psbl.fmt)
		set(afm_file ITCBookman-Light.afm)
	elseif( ${fmt_file} STREQUAL psc.fmt)
		set(afm_file Courier.afm)
	elseif( ${fmt_file} STREQUAL pscb.fmt)
		set(afm_file Courier-Bold.afm)
	elseif( ${fmt_file} STREQUAL pscbo.fmt)
		set(afm_file Courier-BoldOblique.afm)
	elseif( ${fmt_file} STREQUAL psco.fmt)
		set(afm_file Courier-Oblique.afm)
	elseif( ${fmt_file} STREQUAL psh.fmt)
		set(afm_file Helvetica.afm)
	elseif( ${fmt_file} STREQUAL pshb.fmt)
		set(afm_file Helvetica-Bold.afm)
	elseif( ${fmt_file} STREQUAL pshbo.fmt)
		set(afm_file Helvetica-BoldOblique.afm)
	elseif( ${fmt_file} STREQUAL pshn.fmt)
		set(afm_file Helvetica-Narrow.afm)
	elseif( ${fmt_file} STREQUAL pshnb.fmt)
		set(afm_file Helvetica-NarrowBold.afm)
	elseif( ${fmt_file} STREQUAL pshnbo.fmt)
		set(afm_file Helvetica-NarrowBoldOblique.afm)
	elseif( ${fmt_file} STREQUAL pshno.fmt)
		set(afm_file Helvetica-NarrowOblique.afm)
	elseif( ${fmt_file} STREQUAL psho.fmt)
		set(afm_file Helvetica-Oblique.afm)
	elseif( ${fmt_file} STREQUAL psncsb.fmt)
		set(afm_file NewCenturySchlbk-Bold.afm)
	elseif( ${fmt_file} STREQUAL psncsbi.fmt)
		set(afm_file NewCenturySchlbk-BoldItalic.afm)
	elseif( ${fmt_file} STREQUAL psncsi.fmt)
		set(afm_file NewCenturySchlbk-Italic.afm)
	elseif( ${fmt_file} STREQUAL psncsr.fmt)
		set(afm_file NewCenturySchlbk-Roman.afm)
	elseif( ${fmt_file} STREQUAL pspb.fmt)
		set(afm_file Palatino-Bold.afm)
	elseif( ${fmt_file} STREQUAL pspbi.fmt)
		set(afm_file Palatino-BoldItalic.afm)
	elseif( ${fmt_file} STREQUAL pspi.fmt)
		set(afm_file Palatino-Italic.afm)
	elseif( ${fmt_file} STREQUAL pspr.fmt)
		set(afm_file Palatino-Roman.afm)
	elseif( ${fmt_file} STREQUAL pstb.fmt)
		set(afm_file Times-Bold.afm)
	elseif( ${fmt_file} STREQUAL pstbi.fmt)
		set(afm_file Times-BoldItalic.afm)
	elseif( ${fmt_file} STREQUAL psti.fmt)
		set(afm_file Times-Italic.afm)
	elseif( ${fmt_file} STREQUAL pstr.fmt)
		set(afm_file Times-Roman.afm)
	elseif( ${fmt_file} STREQUAL pszcmi.fmt)
		set(afm_file ITCZapfChancery-MediumItalic.afm)
	elseif( ${fmt_file} STREQUAL ssym.fmt)
		set(afm_file Symbol.afm)
		set(OPTIONE )
	elseif( ${fmt_file} STREQUAL pszd.fmt)
		set(afm_file ZapfDingbats.afm)
		set(OPTIONE )
	endif()
	add_custom_command(
		OUTPUT ${OUTPUT_DIR}/${fmt_file}
		DEPENDS ${ADOBE35}/${afm_file}
		COMMAND ${MAKEFMT} ${OPTIONE} -o ${OUTPUT_DIR}/${fmt_file} ${ADOBE35}/${afm_file}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMENT "Generating ${fmt_file} from ${ADOBE35}/${afm_file}"
	)
endforeach(fmt_file)
#
# makefmt - generate .fmt from .afm files
#
foreach( fmt_file ${FMT_FILES} )
	string(REPLACE ".fmt" ".afm" afm_file ${fmt_file} )
	#strip off source folder name if it exists
	get_filename_component(TARGET_FMT ${fmt_file} NAME)
	add_custom_command(
		OUTPUT ${OUTPUT_DIR}/${TARGET_FMT}
		DEPENDS ${afm_file}
		COMMAND ${MAKEFMT} -o ${OUTPUT_DIR}/${TARGET_FMT} ${CMAKE_CURRENT_SOURCE_DIR}/${afm_file}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMENT "Generating ${fmt_file} from ${afm_file}"
	)
endforeach(fmt_file)
#
# fbuild - generate .fve from .gle files
#
foreach( fve_file ${FVE_FILES} )
	string(REPLACE ".fve" ".gle" gle_file ${fve_file} )
	add_custom_command(
		OUTPUT ${OUTPUT_DIR}/${fve_file}
		DEPENDS ${gle_file}
		COMMAND ${FBUILD} ${fve_file}
		COMMAND ${CMAKE_COMMAND} -E rename ${fve_file} ${OUTPUT_DIR}/${fve_file}
		WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMENT "Generating ${fve_file} from ${gle_file}"
	)
endforeach(fve_file)

add_custom_command(
	OUTPUT ${OUTPUT_DIR}/psfont.dat
	COMMAND ${CMAKE_COMMAND} -E copy psfont.dat ${OUTPUT_DIR}/psfont.dat
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_custom_command(
	OUTPUT ${OUTPUT_DIR}/font.dat
	COMMAND ${CMAKE_COMMAND} -E copy font.dat ${OUTPUT_DIR}/font.dat
	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)
file(MAKE_DIRECTORY ${OUTPUT_DIR})

#add_custom_target(
	#create_font_dir ALL
	#COMMAND ${CMAKE_COMMAND} -E make_directory ${OUTPUT_DIR}
	#COMMENT "making font dir"
#)

add_custom_target(fonts ALL
	DEPENDS 
#	create_font_dir
	adobe_fmt_fonts 
	fmt_fonts 
	fve_fonts
	font.dat 
	psfont.dat
)

# transform the lists  - prepend the output directory to them and strip off any source directories

list(TRANSFORM FMT_FILES REPLACE "^.*/" "")
list(TRANSFORM FVE_FILES REPLACE "^.*/" "")
list(TRANSFORM ADOBE_FMT_FILES REPLACE "^.*/" "")
list(TRANSFORM FVE_FILES PREPEND "${OUTPUT_DIR}/")
list(TRANSFORM FMT_FILES PREPEND "${OUTPUT_DIR}/")
list(TRANSFORM ADOBE_FMT_FILES PREPEND "${OUTPUT_DIR}/")
add_custom_target(adobe_fmt_fonts DEPENDS 
	${ADOBE_FMT_FILES}
	makefmt
)

add_custom_target(fmt_fonts DEPENDS 
	adobe_fmt_fonts
	${FMT_FILES}
	makefmt
)

add_custom_target(fve_fonts DEPENDS 
	${FVE_FILES}
	fbuild
)


install(FILES 
	font.dat 
	psfont.dat 
	${ADOBE_FMT_FILES} 
	${FMT_FILES} 
	${FVE_FILES}
	CONFIGURATIONS Release Debug
	DESTINATION font)

=== src/gle/CMakeLists.txt ===

set(GLE_SOURCES
	bitmap/img2ps.cpp
	bitmap/lzwencode.cpp
	bitmap/glegif.cpp
	bitmap/glejpeg.cpp
	bitmap/gletiff.cpp
	bitmap/glepng.cpp
	bitmap/ascii85.cpp
	letzfitz/let.cpp
	letzfitz/fit.cpp
	letzfitz/ffit.cpp
	surface/gsurface.cpp
	surface/hide.cpp
	surface/fcontour.cpp
	surface/ffitcontour.cpp
	surface/gcontour.cpp
	tokens/Tokenizer.cpp
	tokens/StringKeyHash.cpp
	tokens/BinIO.cpp
	axis.cpp
	b_tab.cpp
	b_text.cpp
	begin.cpp
	core.cpp
	curve.cpp
	color.cpp
	drawit.cpp
	eval.cpp
	fitbez.cpp
	fitcf.cpp
	fn.cpp
	font.cpp
	general.cpp
	op_def.cpp
	gprint.cpp
	graph.cpp
	graph2.cpp
	key.cpp
	keyword.cpp
	leastsq.cpp
	memory.cpp
	mychar.cpp
	pass.cpp
	polish.cpp
	run.cpp
	savgol.cpp
	sub.cpp
	tex.cpp
	token.cpp
	var.cpp
	cutils.cpp
	texinterface.cpp
	d_ps.cpp
	d_svg.cpp
	d_x.cpp
	d_dummy.cpp
	d_cairo.cpp
	config.cpp
	numberformat.cpp
	glearray.cpp
	cmdline.cpp
	gle-block.cpp
	gle-sourcefile.cpp
	gle-interface.cpp
	gle-base.cpp
	gle-datatype.cpp
	gle-poppler.cpp
	builtin-double.cpp
	cutils.cpp
	file_io.cpp
)

set( GLEBTOOL_SOURCES
	cutils.cpp
	file_io.cpp
	glebtool.cpp
)

add_custom_command(
 	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/glerc
 	COMMAND ${CMAKE_COMMAND} -E echo begin config gle > ${CMAKE_CURRENT_BINARY_DIR}/glerc
 	COMMAND ${CMAKE_COMMAND} -E echo current = ${PROJECT_VERSION} >> ${CMAKE_CURRENT_BINARY_DIR}/glerc
 	COMMAND ${CMAKE_COMMAND} -E echo end config >> ${CMAKE_CURRENT_BINARY_DIR}/glerc
  	COMMENT "Generating glerc in ${CMAKE_CURRENT_BINARY_DIR}"
  	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
)

add_library(gle_common OBJECT ${GLE_SOURCES})
add_executable( gle $<TARGET_OBJECTS:gle_common> gle.cpp )
add_library(gle-graphics_s STATIC $<TARGET_OBJECTS:gle_common> gle.cpp)
add_library(gle-graphics SHARED $<TARGET_OBJECTS:gle_common> gle.cpp)
target_compile_definitions(gle-graphics_s PRIVATE -DHAVE_LIBGLE)
target_compile_definitions(gle-graphics PRIVATE -DHAVE_LIBGLE)
add_custom_target( glerc_file ALL DEPENDS glerc )

target_compile_features(gle_common PUBLIC cxx_std_17)
target_compile_features(gle PUBLIC cxx_std_17)
target_compile_features(gle-graphics_s PUBLIC cxx_std_17)
target_compile_features(gle-graphics PUBLIC cxx_std_17)

set_target_properties(gle PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
set_target_properties(gle-graphics_s PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})
set_target_properties(gle-graphics PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})

if(UNIX AND NOT APPLE)
	target_link_options(gle-graphics PUBLIC -fPIC)
	target_link_options(gle-graphics_s PUBLIC -fPIC)
endif()


target_link_libraries ( gle LINK_PUBLIC
	TIFF::TIFF
	${ZLIB_LIBRARIES}
	${JPEG_LIBRARIES}
	${PNG_LIBRARIES}
	${CAIRO_LIBRARIES}
	${PIXMAN_LIBRARIES}
	)

target_link_libraries ( gle-graphics LINK_PUBLIC
	TIFF::TIFF
	${ZLIB_LIBRARIES}
	${JPEG_LIBRARIES}
	${PNG_LIBRARIES}
	${CAIRO_LIBRARIES}
	${PIXMAN_LIBRARIES}
	)

if(ZSTD_FOUND)
	target_link_libraries ( gle LINK_PUBLIC
 		zstd::libzstd_static
 	)
	target_link_libraries ( gle-graphics LINK_PUBLIC
 		zstd::libzstd_static
 	)
endif()

if(DEFLATE_FOUND)
	target_link_libraries ( gle LINK_PUBLIC
		${DEFLATE_LIBRARIES}
	)
	target_link_libraries ( gle-graphics LINK_PUBLIC
		${DEFLATE_LIBRARIES}
	)
endif()

if(JBIG_FOUND)
	target_link_libraries ( gle LINK_PUBLIC
		JBIG::JBIG
	)
	target_link_libraries ( gle-graphics LINK_PUBLIC
		JBIG::JBIG
	)
endif()

if(LibLZMA_FOUND)
	target_link_libraries ( gle LINK_PUBLIC
		${LIBLZMA_LIBRARIES}
	)
	target_link_libraries ( gle-graphics LINK_PUBLIC
		${LIBLZMA_LIBRARIES}
	)
endif()
if(POPPLER_FOUND)
	target_link_libraries ( gle LINK_PUBLIC
		${POPPLER_LIBRARIES_GLE}
 	)
	target_link_libraries ( gle-graphics LINK_PUBLIC
		${POPPLER_LIBRARIES_GLE}
 	)
endif()

if(WIN32)
	target_link_libraries ( gle-graphics LINK_PUBLIC
		opengl32.lib
		wsock32.lib
		Ws2_32.lib
		msimg32.lib
		)
	target_link_libraries( gle LINK_PUBLIC
		opengl32.lib
		wsock32.lib
		Ws2_32.lib
		msimg32.lib
		)
endif()

if(APPLE AND NOT LibLZMA_FOUND)
	target_link_libraries ( gle-graphics LINK_PUBLIC
		lzma
	)
	target_link_libraries ( gle LINK_PUBLIC
		lzma
	)
endif()

install(TARGETS gle
		CONFIGURATIONS Release Debug
		RUNTIME )

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/glerc
		CONFIGURATIONS Release Debug
		DESTINATION . )

=== src/glebtool/CMakeLists.txt ===
add_executable(glebtool
	glebtool.cpp
	../gle/cutils.cpp
	../gle/file_io.cpp
)

if(WIN32)
	target_link_libraries(glebtool LINK_PUBLIC Ws2_32.lib ) 
endif()

set_target_properties(glebtool PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 
install(TARGETS glebtool
		CONFIGURATIONS Release Debug
		RUNTIME )

=== src/gui/CMakeLists.txt ===
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
#
# -- Qt5  set Qt5_DIR
#
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

find_package(Qt5 COMPONENTS
	Widgets
	Network
	DBus
	Gui
	OpenGL
	REQUIRED)

add_executable(qgle WIN32 MACOSX_BUNDLE
	3dviewer.cpp
	about.cpp
	amove.cpp
	arc.cpp
	circle.cpp
	colourbutton.cpp
	colourpicker.cpp
	component.cpp
	consolewindow.cpp
	dialogues.cpp
#    downloader.cpp
	drawingobject.cpp
	ellipse.cpp
	fileinfo.cpp
	gledrawing.cpp
	grid.cpp
	line.cpp
	main.cpp
	mainwindow.cpp
	newfile.cpp
	objectblocks.cpp
	polararray.cpp
	propertyeditor.cpp
	propertymodel.cpp
	qgle_statics.cpp
	qgs.cpp
	qgslibloader.cpp
	serverthread.cpp
	settings.cpp
	settings_dialogue.cpp
	snapline.cpp
	text.cpp
	variantdelegate.cpp
	$<$<PLATFORM_ID:Darwin>:macspecific.cpp>
	qgle.qrc
	$<$<PLATFORM_ID:Windows>:qgle.rc>
)
if(EXTRA_GSLIB_SEARCH_LOCATION)
target_compile_definitions(qgslibloader.cpp -DEXTRA_GSLIB_SEARCH_LOCATION="${EXTRA_GSLIB_SEARCH_LOCATION}")
endif()
#
# - care must be taken with library order for Linux
#
# order matters: first static files (and libgle), then dynamic libraries
list(APPEND QGLE_LIBRARIES
	gle-graphics_s
	${ZLIB_LIBRARIES}
	${PNG_LIBRARIES}
	${PIXMAN_LIBRARIES}
)
if(UNIX OR APPLE)
	# these come in QT on windows ??
	list(APPEND QGLE_LIBRARIES
		${JPEG_LIBRARIES}
		TIFF::TIFF
	)
endif()

list(APPEND QGLE_LIBRARIES
	Qt::Core
	Qt::Gui
	Qt::Network
	Qt::Widgets
	Qt::OpenGL
	${CAIRO_LIBRARIES}
	${CMAKE_DL_LIBS}
)

if(UNIX AND NOT APPLE)
	list(APPEND QGLE_LIBRARIES
 		glut
 		GLU
 		GL
# 		Qt5::QWaylandIntegrationPlugin
	)
endif()
if(WIN32)
	list(APPEND QGLE_LIBRARIES
	 msimg32.lib
	 opengl32.lib
	 glu32.lib
	)
endif()

if(ZSTD_FOUND)
	list(APPEND QGLE_LIBRARIES
 		zstd::libzstd_static
 	)
endif()

if(DEFLATE_FOUND)
	list(APPEND QGLE_LIBRARIES
		${DEFLATE_LIBRARIES}
	)
endif()

if(JBIG_FOUND)
	list(APPEND QGLE_LIBRARIES
		JBIG::JBIG
	)
endif()

if(LibLZMA_FOUND)
	list(APPEND QGLE_LIBRARIES
		${LIBLZMA_LIBRARIES}
	)
endif()

if(POPPLER_FOUND)
	list(APPEND QGLE_LIBRARIES
		${POPPLER_LIBRARIES_GLE}
 	)
endif()

target_link_libraries ( qgle LINK_PUBLIC
	${QGLE_LIBRARIES}
	)

if(UNIX AND NOT APPLE)
 	target_link_options(qgle PUBLIC -no-pie)
	qt_import_plugins( qgle
  		INCLUDE_BY_TYPE platforms
	)
endif()

if(APPLE)
	#openGL is deprecated on macOS starting at 10.9; this silences the warning
	add_compile_definitions(Q_OS_APPLE)
	add_compile_options(-Wno-deprecated-declarations)
	target_link_libraries ( qgle LINK_PUBLIC
	lzma
	"-framework AppKit"
	"-framework GSS"
	"-framework IOKit"
	"-framework Security"
    "-framework Cocoa"
    "-framework OpenGL"
    "-framework SystemConfiguration"
    "-framework Carbon"
	)
endif()
target_compile_features(qgle PUBLIC cxx_std_17)
set_target_properties(qgle PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})

install(TARGETS qgle RUNTIME BUNDLE DESTINATION bin )

=== src/makefmt/CMakeLists.txt ===
add_executable(makefmt
	makefmt.cpp 
	parseAFM.cpp
	../gle/cutils.cpp
	../gle/file_io.cpp
)

if(WIN32)
	target_link_libraries(makefmt LINK_PUBLIC Ws2_32.lib ) 
endif()

set_target_properties(makefmt PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX}) 

install(TARGETS makefmt
		CONFIGURATIONS Release Debug
		RUNTIME )

=== src/manip/CMakeLists.txt ===
add_executable(manip
	cell.cpp
	cmd.cpp
	eval.cpp
	filemenu.cpp
	fn.cpp
	general.cpp
	keyword.cpp
	manip.cpp
	mjl.cpp
	polish.cpp
	sub.cpp
	token.cpp
	var.cpp
	varargs.cpp
	$<$<PLATFORM_ID:Linux>:unix_extra.cpp>
	$<$<PLATFORM_ID:Linux>:unixinkey.cpp>
	$<$<PLATFORM_ID:Linux>:unixscr.cpp>
	$<$<PLATFORM_ID:Darwin>:unix_extra.cpp>
	$<$<PLATFORM_ID:Darwin>:unixinkey.cpp>
	$<$<PLATFORM_ID:Darwin>:unixscr.cpp>
	$<$<PLATFORM_ID:Windows>:turbo.cpp>
	$<$<PLATFORM_ID:Windows>:turboscr.cpp>
	$<$<PLATFORM_ID:Windows>:inkey.cpp>
	../gle/cutils.cpp
	../gle/file_io.cpp
)

if(WIN32)
	target_link_libraries(manip LINK_PUBLIC
		opengl32.lib
		wsock32.lib
		Ws2_32.lib
		msimg32.lib
	)
endif()

target_link_libraries(manip PRIVATE ${CURSES_LIBRARIES})
target_include_directories(manip SYSTEM PRIVATE ${CURSES_INCLUDE_DIRS})

set_target_properties(manip PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})

install(TARGETS manip
		CONFIGURATIONS Release Debug
		RUNTIME )

=== debian/changelog ===
gle-graphics (4.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Recommend libgs10 instead of libgs9. Closes: #1115362
  * Build-depend on pkgconf instead of obsolete pkg-config.
  * Update Standards-Version to 4.7.2 (no changes)
  * New patch: correct ifdef with multiple tokens
  * New patch: fix CMake Warning(dev): CMP0167

 -- Christian T. Steigies <cts@debian.org>  Sun, 31 Aug 2025 20:50:52 +0200

=== debian/control ===
Source: gle-graphics
Section: graphics
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Christian T. Steigies <cts@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               freeglut3-dev,
               ghostscript,
               libboost-dev,
               libcairo-dev,
               libgs-dev,
               libjpeg-dev,
               libpng-dev,
               libpoppler-glib-dev,
               qtbase5-dev,
               libqt5opengl5-dev,
               libtiff-dev,
               libtool,
               libncurses-dev,
               pkgconf,
               extra-cmake-modules
Standards-Version: 4.7.2
Homepage: http://glx.sf.net
Vcs-Browser: https://salsa.debian.org/science-team/gle-graphics
Vcs-Git: https://salsa.debian.org/science-team/gle-graphics.git

Package: gle-graphics
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: libgs10, gle-graphics-manual
Description: Graphics Layout Engine
 GLE is a graphics scripting language designed for creating publication
 quality figures such as charts, plots, graphs, and diagrams. It
 supports various chart types (including function plot, histogram, bar
 chart, scatter plot, contour plot, color map, and surface plot) through
 a simple but flexible set of graphing commands; more complex output can
 be created by relying on its scripting language, which is full featured
 with subroutines, variables, and logic control.
 .
 GLE relies on LaTeX for text output and supports mathematical formulae
 in graphs and figures. Output formats include (E)PS, PDF, JPEG, and PNG.

Package: gle-graphics-glebtool
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gle-graphics (>= ${source:Version}) 
Description: Graphics Layout Engine glebtool
 glebtool is used to build the PDF gle-graphics-manual

=== debian/tests/control ===
Test-Command: gle -info
Depends: gle-graphics

=== debian/watch ===
version=4
opts="mode=git" https://github.com/vlabella/GLE.git \
  refs/tags/v([\d\.]+) debian uupdate

## gle-graphics 4.3.8

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,12 @@
 #
 # -- CMakeLists.txt for GLE - Graphics Layout Engine
 #
-cmake_minimum_required (VERSION 3.18)
+cmake_minimum_required (VERSION 3.30)
 cmake_policy(SET CMP0091 NEW) 	# windows static runtimes selection
 #cmake_policy(SET CMP0167 NEW)	# The FindBoost module is removed. only for cmake 3.30 and later live with the warning for now
 cmake_policy(SET CMP0074 NEW)	# uses <PackageName>_ROOT variables.
+set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
 include(CheckIncludeFile)
 include(CheckIncludeFiles)
 include(CheckIncludeFileCXX)
@@ -15,8 +17,8 @@
 	list(INSERT CMAKE_MODULE_PATH 0 ${ECM_MODULE_PATH})
 endif()
 
-set( CMAKE_OSX_DEPLOYMENT_TARGET "10.14" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple
-project( gle VERSION 4.3.7 )
+set( CMAKE_OSX_DEPLOYMENT_TARGET "10.15" CACHE STRING "Minimum OS X deployment version")	# minimum supported by apple
+project( gle VERSION 4.3.8 )
 add_compile_definitions(GLEVN="${PROJECT_VERSION}")
 set( CMAKE_DEBUG_POSTFIX  "d")
 #
@@ -30,10 +32,14 @@
 
 option(BUILD_GUI "Build the GUI - gle Previewer" ON)
 option(BUILD_MANIP "Build manip program" BUILD_MANIP_DEFAULT)
+option(BUILD_GLEBTOOL "Build glebtool program - deprecated" OFF)
+option(INSTALL_FBUILD "Install the fbuild program - only needed during gle build phase" OFF)
+option(INSTALL_MAKEFMT "Install the makefmt program - only needed during gle build phase" OFF)
 option(MSVC_USE_STATIC_RUNTIME "Build and link against the windows static runtime (/MT) (windows only)" OFF)
 option(GLE_EXAMPLES_LIBRARY_PATH "Path to gle-examples.  Only needed when using cpack to build distributables" "./gle-examples")
 option(GLE_USER_MANUAL_PATH "Path to gle-manual when gle-manual.pdf resides.  Only needed when using cpack to build distributables" "./gle-manual")
 option(EXTRA_GSLIB_SEARCH_LOCATION "Extra path for searching for gslib on linux and macOS" OFF)
+# option(BITMAP_CREATION_POPPLER "Use poppler library for bitmap creation instead of ghostscript" OFF)
 
 if(NOT DEFINED POPPLER_INTERFACE)
 	# poppler interface defaults if not set -> CPP for Windows, GLIB for Linux and Apple/Darwin
@@ -281,13 +287,3 @@
 	set(HAS_DEBUG )
 	string(COMPARE NOTEQUAL "${PIXMAN_DEBUG}" "PIXMAN_DEBUG-NOTFOUND" HAS_DEBUG)
 	if(HAS_DEBUG)
-		list(APPEND PIXMAN_LIBRARIES "optimized")
-		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
-		list(APPEND PIXMAN_LIBRARIES "debug")
-		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_DEBUG})
-	else()
-		list(APPEND PIXMAN_LIBRARIES ${PIXMAN_RELEASE})
-	endif()
-else()
-	find_library(PIXMAN_LIBRARIES NAMES pixman pixmand pixman-1 PATHS ${PIXMAN_ROOT} PATH_SUFFIXES lib REQUIRED)
-	string(COMPARE NOTEQUAL "${PIXMAN_LIBRARIES}" "PIXMAN_LIBRARIES-NOTFOUND" PIXMAN_FOUND)

=== src/fbuild/CMakeLists.txt ===
#
# -- fbuild - used during build phase to create font .fve files
#
add_executable(fbuild
	fbuild.cpp
	../gle/token.cpp
	../gle/cutils.cpp
	../gle/file_io.cpp
)
if(WIN32)
	target_link_libraries(fbuild LINK_PUBLIC Ws2_32.lib )
endif()
set_target_properties(fbuild PROPERTIES DEBUG_POSTFIX ${CMAKE_DEBUG_POSTFIX})

if(INSTALL_FBUILD)
install(TARGETS fbuild
		CONFIGURATIONS Release Debug
		RUNTIME )
endif()

=== src/gle/CMakeLists.txt ===
--- 
+++ 
@@ -166,7 +166,7 @@
 	target_link_libraries ( gle LINK_PUBLIC
 		${POPPLER_LIBRARIES_GLE}
  	)
-	target_link_libraries ( gle-graphics LINK_PUBLIC
+	target_link_libraries ( gle-graphics LINK_PRIVATE
 		${POPPLER_LIBRARIES_GLE}
  	)
 endif()

=== debian/changelog ===
gle-graphics (4.3.8-1) experimental; urgency=medium

  * New upstream release.
  * Add upstream patch to eliminate stackunderflow in qgle
  * Add upstream patch to set GLE_TOP when creating inittex.ini

 -- Christian T. Steigies <cts@debian.org>  Sun, 19 Oct 2025 18:25:44 +0200

=== debian/control ===
--- 
+++ 
@@ -13,12 +13,12 @@
                libjpeg-dev,
                libpng-dev,
                libpoppler-glib-dev,
-               qtbase5-dev,
-               libqt5opengl5-dev,
+               libqt6opengl6-dev,
                libtiff-dev,
                libtool,
                libncurses-dev,
                pkgconf,
+               qt6-5compat-dev,
                extra-cmake-modules
 Standards-Version: 4.7.2
 Homepage: http://glx.sf.net
@@ -40,9 +40,3 @@
  .
  GLE relies on LaTeX for text output and supports mathematical formulae
  in graphs and figures. Output formats include (E)PS, PDF, JPEG, and PNG.
-
-Package: gle-graphics-glebtool
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, gle-graphics (>= ${source:Version}) 
-Description: Graphics Layout Engine glebtool
- glebtool is used to build the PDF gle-graphics-manual

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/default.mk

ifeq (,$(filter terse,$(DEB_BUILD_OPTIONS)))
    export DH_VERBOSE = 1
endif
### testing
export DH_VERBOSE = 1
###

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1

CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

empty :=

#DEB_CMAKE_EXTRA_FLAGS = \
#    -DGLE_TOP_DIR=/usr/share/gle-graphics/$(DEB_VERSION_UPSTREAM) \
#    -CMAKE_INSTALL_PREFIX=/usr/share/gle-graphics/4.3.3 \
#    $(empty)

# fix build problems on the hurd
ifeq ($(DEB_HOST_ARCH),hurd-i386)
    export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed -Wl,-lpthread -Wl,--as-needed -fPIC
endif

# enable debugging
#export DEB_CPPFLAGS_MAINT_APPEND = -g
export DEB_CFLAGS_MAINT_APPEND = -g

# define libgs search path used by qgle
HEAD = /usr/lib/
LIBGS := $(HEAD)$(DEB_HOST_MULTIARCH)

# source date string instead of \today in gle-manual
# use only digits, locale month is not reproducible
DATE_FMT = %Y-%m-%d
SOURCE_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)"  2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
# https://reproducible-builds.org/docs/source-date-epoch/
export SOURCE_DATE_EPOCH ?= $(shell dpkg-parsechangelog -STimestamp)

%:
	dh $@

override_dh_auto_build:
	# write libgs search path to debian specific header file, used by find_gs patch
	echo "const char *debian_lib = \""$(LIBGS)"\";" > src/gui/debian_gs.h
	dh_auto_build

	sed s/@GLE_VERSION@/$(DEB_VERSION_UPSTREAM)/ debian/gle.1.in | sed s/@GLE_INSTALL_DATA@/"\/usr\/share\/gle-graphics"/  > debian/gle.1

override_dh_auto_clean:
	dh_auto_clean
	-rm src/TeX/inittex.ini

# manpages are updated only when needed, call this target manually
manpage:
	docbook-to-man debian/manip.sgml > debian/manip.1
	docbook-to-man debian/qgle.sgml > debian/qgle.1
	docbook-to-man debian/glebtool.sgml > debian/glebtool.1
